#!/usr/local/bin/perl

#Illinois Open Source License
#
#University of Illinois
#Open Source License
#
#Copyright © 2008,    Board of Trustees of the University of Illinois.  All rights reserved.
#
#Developed by:
#
#MONET Research Group in the Department of Computer Science
#The University of Illinois at Urbana-Champaign
#http://cairo.cs.uiuc.edu

# Distributed Protocols Research Group in the Department of Computer Science
# The University of Illinois at Urbana-Champaign
# http://dprg.cs.uiuc.edu/

#Long Vu, longvu2@cs.uiuc.edu
#Indranil Gupta, indy@cs.uiuc.edu
#Klara Nahrstedt, klara@cs.uiuc.edu
#Jin Liang, jinliangcu@gmail.com
#
#Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal with the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
#
#    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimers.
#    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimers in the documentation and/or other materials provided with the distribution.
#    * Neither the names of The Monet Group or The University of Illinois at Urbana-Champaign, nor the names of its contributors may be used to endorse or promote products derived from this Software without specific prior written permission.
#
#THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
#PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN 
#AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.


use strict;
use Sys::Hostname;

my ($crawlerPath, $serverListFile, $maxResponse) = @ARGV;
if (scalar(@ARGV) != 3){
	print "Usage: crawler.pl <crawlerPath> <serverListFile> <maxResponse>\n"
;
	exit;
}

my $cmd;
my $datDir = "data/";
my $xmlDir = "channelID/";
my $crawler = $crawlerPath;

my @inFile;
foreach my $sourceFile (<$xmlDir*.txt>) {
 	$sourceFile =~ s/$xmlDir//g;
 	$sourceFile =~ s/\.txt//g;
 	push(@inFile, $sourceFile);
 	$cmd = "mkdir ".$datDir.$sourceFile;
    	print $cmd."\n";
   	system($cmd);

}

#Take message from XML file
@inFile = sort @inFile;
my @messArr;

foreach my $i (0..scalar(@inFile)-1)
{
    # go through xml files and get corresponding pattern, feed the appropriate binary file
    my $input = $xmlDir.$inFile[$i].".txt";
    my @messages = `grep 'e9|03' $input`;
    # need several information for one crawler of one channel
    push(@messArr, $inFile[$i]);
    my $tmp = $messages[2]; 
    chomp($tmp);
    $tmp =~ s/\|//g;
    $tmp =~ s/.*?e903//g;
    push(@messArr, "e903".$tmp);

    $tmp = $messages[scalar(@messages) - 2];
    chomp($tmp);
    $tmp =~ s/\|//g;
    $tmp =~ s/.*?e903//g;
    push(@messArr, "e903".$tmp);

    $tmp = $messages[scalar(@messages) - 1];
    chomp($tmp);
    $tmp =~ s/\|//g;
    $tmp =~ s/.*?e903//g;
    push(@messArr, "e903".$tmp);
}

my $round = 0;
my $sleepAmount = 60 *10 ; # 10 minute

my $hostName = hostname;

while (1){
    #convert to Chinese time
    my ($sec,$min,$hour,$mday,$mon,$year, $wday,$yday,$isdst) = localtime(time);
    $mon++;
    $year += 1900;
    my $outFile = $mon."_".$mday."_".$year."_";
    my $subDir = "";
    if ($hour < 12 ) {
	$hour +=12;
        $outFile = $outFile.$hour."_";
	$subDir = $hour;
    }else{
	$hour -=12;
	if ($hour < 10){
		$outFile .="0";
		$subDir  .="0";
	}
	
        $outFile .= $hour."_";
	$subDir .= $hour."/";
    }
    if ($min < 10) {
        $outFile = $outFile."0".$min;
    }else{
        $outFile = $outFile.$min;
    }

    for (my $i = 0; $i < scalar(@messArr); $i =$i+4){
        my $file = $outFile."_".$messArr[$i]."_".$hostName;
        $cmd = "./".$crawler." ".$messArr[$i+1]." ".$messArr[$i+2]." $messArr[$i+3]  $serverListFile   $maxResponse  ".$datDir.$messArr[$i]."/".$file."  &  ";
        system($cmd);
	print $cmd."\n";
  
   }
   sleep($sleepAmount);
   `killall -q crawler`;
}

